require "import"
import "android.content.Context"
import "android.os.Vibrator"
import "android.media.ToneGenerator"
import "android.media.AudioManager"
import "android.widget.*"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"
import "android.text.Html"

local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(40)

local translationResult = ""
local languageCodes = {
    ["English"] = "en",
    ["Azerbaijani"] = "az",
    ["Aymara"] = "ay",
    ["Albanian"] = "sq",
    ["Amharic"] = "am",
    ["Arabic"] = "ar",
    ["Armenian"] = "hy",
    ["Assamese"] = "as",
    ["Afrikaans"] = "af",
    ["Bambara"] = "bam",
    ["Basque"] = "eu",
    ["Belarusian"] = "be",
    ["Bengali"] = "bn",
    ["Burmese"] = "my",
    ["Bulgarian"] = "bg",
    ["Bosnian"] = "bs",
    ["Bhojpuri"] = "bhj",
    ["Welsh"] = "cy",
    ["Hungarian"] = "hu",
    ["Vietnamese"] = "vi",
    ["Hawaiian"] = "haw",
    ["Galician"] = "gl",
    ["Greek"] = "el",
    ["Georgian"] = "ka",
    ["Guaraní"] = "gn",
    ["Gujarati"] = "gu",
    ["Danish"] = "da",
    ["Dogri"] = "dog",
    ["Zulu"] = "zu",
    ["Hebrew"] = "he",
    ["Igbo"] = "ig",
    ["Yiddish"] = "yi",
    ["Ilokano"] = "ilo",
    ["Indonesian"] = "id",
    ["Irish"] = "ga",
    ["Icelandic"] = "is",
    ["Spanish"] = "es",
    ["Italian"] = "it",
    ["Yoruba"] = "yo",
    ["Kazakh"] = "kk",
    ["Kannada"] = "kn",
    ["Catalan"] = "ca",
    ["Quechua"] = "qu",
    ["Kyrgyz"] = "ky",
    ["Chinese (Traditional)"] = "zh-TW",
    ["Chinese (Simplified)"] = "zh-CN",
    ["Konkani"] = "kok",
    ["Korean"] = "ko",
    ["Corsican"] = "co",
    ["Xhosa"] = "xh",
    ["Haitian Creole"] = "ht",
    ["Kriolu"] = "kri",
    ["Kurdish (Kurmanji)"] = "ku",
    ["Kurdish (Sorani)"] = "ckb",
    ["Khmer"] = "km",
    ["Lao"] = "lo",
    ["Latin"] = "la",
    ["Latvian"] = "lv",
    ["Lingala"] = "ln",
    ["Lithuanian"] = "lt",
    ["Luganda"] = "lg",
    ["Luxembourgish"] = "lb",
    ["Maithili"] = "mai",
    ["Macedonian"] = "mk",
    ["Malagasy"] = "mg",
    ["Malay"] = "ms",
    ["Malayalam"] = "ml",
    ["Divehi"] = "dv",
    ["Maltese"] = "mt",
    ["Maori"] = "mi",
    ["Marathi"] = "mr",
    ["Meitei (Manipuri)"] = "mni",
    ["Mizo"] = "lus",
    ["Mongolian"] = "mn",
    ["German"] = "de",
    ["Nepali"] = "ne",
    ["Dutch"] = "nl",
    ["Norwegian"] = "no",
    ["Odia"] = "or",
    ["Oromo"] = "om",
    ["Punjabi"] = "pa",
    ["Persian"] = "fa",
    ["Polish"] = "pl",
    ["Portuguese"] = "pt",
    ["Pashto"] = "ps",
    ["Kinyarwanda"] = "rw",
    ["Romanian"] = "ro",
    ["Russian"] = "ru",
    ["Samoan"] = "sm",
    ["Sanskrit"] = "sa",
    ["Cebuano"] = "ceb",
    ["Northern Sotho"] = "nso",
    ["Serbian"] = "sr",
    ["Sotho"] = "st",
    ["Sinhala"] = "si",
    ["Sindhi"] = "sd",
    ["Slovak"] = "sk",
    ["Slovenian"] = "sl",
    ["Somali"] = "so",
    ["Swahili"] = "sw",
    ["Sundanese"] = "su",
    ["Tajik"] = "tg",
    ["Thai"] = "th",
    ["Tamil"] = "ta",
    ["Tatar"] = "tt",
    ["Telugu"] = "te",
    ["Tigrinya"] = "ti",
    ["Tsonga"] = "ts",
    ["Turkish"] = "tr",
    ["Turkmen"] = "tk",
    ["Uzbek"] = "uz",
    ["Uighur"] = "ug",
    ["Ukrainian"] = "uk",
    ["Urdu"] = "ur",
    ["Filipino"] = "fil",
    ["Finnish"] = "fi",
    ["French"] = "fr",
    ["Frisian"] = "fy",
    ["Hausa"] = "ha",
    ["Hindi"] = "hi",
    ["Hmong"] = "hmn",
    ["Croatian"] = "hr",
    ["Chichewa"] = "ny",
    ["Cheyenne"] = "ny",
    ["Czech"] = "cs",
    ["Swedish"] = "sv",
    ["Shona"] = "sn",
    ["Scottish Gaelic"] = "gd",
    ["Ewe"] = "ee",
    ["Esperanto"] = "eo",
    ["Estonian"] = "et",
    ["Javanese"] = "jv",
    ["Japanese"] = "ja",
}
local items = {
    "English",
    "Azerbaijani",
    "Aymara",
    "Albanian",
    "Amharic",
    "Arabic",
    "Armenian",
    "Assamese",
    "Afrikaans",
    "Bambara",
    "Basque",
    "Belarusian",
    "Bengali",
    "Burmese",
    "Bulgarian",
    "Bosnian",
    "Bhojpuri",
    "Welsh",
    "Hungarian",
    "Vietnamese",
    "Hawaiian",
    "Galician",
    "Greek",
    "Georgian",
    "Guaraní",
    "Gujarati",
    "Danish",
    "Dogri",
    "Zulu",
    "Hebrew",
    "Igbo",
    "Yiddish",
    "Ilokano",
    "Indonesian",
    "Irish",
    "Icelandic",
    "Spanish",
    "Italian",
    "Yoruba",
    "Kazakh",
    "Kannada",
    "Catalan",
    "Quechua",
    "Kyrgyz",
    "Chinese (Traditional)",
    "Chinese (Simplified)",
    "Konkani",
    "Korean",
    "Corsican",
    "Xhosa",
    "Haitian Creole",
    "Kriolu",
    "Kurdish (Kurmanji)",
    "Kurdish (Sorani)",
    "Khmer",
    "Lao",
    "Latin",
    "Latvian",
    "Lingala",
    "Lithuanian",
    "Luganda",
    "Luxembourgish",
    "Maithili",
    "Macedonian",
    "Malagasy",
    "Malay",
    "Malayalam",
    "Divehi",
    "Maltese",
    "Maori",
    "Marathi",
    "Meitei (Manipuri)",
    "Mizo",
    "Mongolian",
    "German",
    "Nepali",
    "Dutch",
    "Norwegian",
    "Odia",
    "Oromo",
    "Punjabi",
    "Persian",
    "Polish",
    "Portuguese",
    "Pashto",
    "Kinyarwanda",
    "Romanian",
    "Russian",
    "Samoan",
    "Sanskrit",
    "Cebuano",
    "Northern Sotho",
    "Serbian",
    "Sotho",
    "Sinhala",
    "Sindhi",
    "Slovak",
    "Slovenian",
    "Somali",
    "Swahili",
    "Sundanese",
    "Tajik",
    "Thai",
    "Tamil",
    "Tatar",
    "Telugu",
    "Tigrinya",
    "Tsonga",
    "Turkish",
    "Turkmen",
    "Uzbek",
    "Uighur",
    "Ukrainian",
    "Urdu",
    "Filipino",
    "Finnish",
    "French",
    "Frisian",
    "Hausa",
    "Hindi",
    "Hmong",
    "Croatian",
    "Chichewa",
    "Cheyenne",
    "Czech",
    "Swedish",
    "Shona",
    "Scottish Gaelic",
    "Ewe",
    "Esperanto",
    "Estonian",
    "Javanese",
    "Japanese",
}

function capitalizeFirstWord(str)
    return str:gsub("^%l", string.upper)
end

function addPunctuation(str)
    return str .. "."
end

function hasInternetConnection()
    local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)
    local networkInfo = connectivityManager.getActiveNetworkInfo()
    return networkInfo ~= nil and networkInfo.isConnected()
end

if not hasInternetConnection() then
    service.asyncSpeak("No internet connection. Unable to translate language")
    return false
end

local layout = {
    GridView,
    id = "grid",
    numColumns = 1,
    layout_width = "fill",
    layout_height = "fill"
}

local dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))

dlg.setTitle("Google Translate")
.setMessage("Select the language you want to translate to")
.setButton("Exit", nil)
.show()

grid.onItemClick = function(l, v)
    dlg.dismiss()
    task(500, function()
        local language = v.text
        local defaultLanguage = Locale.getDefault().getLanguage()
        local languageCode = languageCodes[language]

        if languageCode then
            local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(this.getText(node))
            url = url .. "&tl=" .. languageCode

            Http.get(url, function(status, result)
                if status == 200 then
                    local translation = tostring(Html.fromHtml(result:match('<div class="result%-container">([^<]+)</div>')))
                    translation = capitalizeFirstWord(translation)
                    translation = addPunctuation(translation)
                    translationResult = translationResult .. translation
                    service.setText(translationResult)
                    service.speak("Translating text: " .. translationResult)
                    vibrator.vibrate(100)
                else
                    print("Sorry, an error occurred.\n Possible solutions:\n - Make sure you are connected to the internet.\n - Try to ensure a stable internet connection.\n Note: Some elements, images, text fields, etc., may not be translated.")
                    vibrator.vibrate(200)
                    service.playSoundTick()
                end
            end)
        else
            print("Language not supported")
            vibrator.vibrate(200)
            service.playSoundClock()
        end
    end)
end
